package ru.myitschool.work.ui.userInfo

import ru.myitschool.work.ui.searchuser.SearchUserViewModel



import android.os.Bundle
import android.view.View
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.navigation.fragment.findNavController
import dagger.hilt.android.AndroidEntryPoint
import ru.myitschool.work.R
import ru.myitschool.work.databinding.FragmentSearchUserBinding
import ru.myitschool.work.databinding.FragmentUserInfoBinding
import ru.myitschool.work.ui.profile.ProfileDestination
import ru.myitschool.work.ui.searchuser.SearchUserDestination
import ru.myitschool.work.utils.collectWhenStarted


@AndroidEntryPoint
class UserInfoFragment : Fragment(R.layout.fragment_user_info) {

    private var _binding: FragmentUserInfoBinding? = null
    private val binding: FragmentUserInfoBinding get() = _binding!!


    private val viewModel: UserInfoViewModel by viewModels()

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        _binding = FragmentUserInfoBinding.bind(view)

        initCallback()
        subscribe()

    }

    private fun initCallback() {
        binding.floatingActionButton2.setOnClickListener { viewModel.closeSearchUser() }
    }

    private fun subscribe() {
        viewModel.action.collectWhenStarted(this) { action ->
            when (action) {
                is UserInfoViewModel.Action.OpenProfile -> {
                    findNavController().navigate(SearchUserDestination) {
                        popUpTo<SearchUserDestination> { inclusive = true }
                    }
                }
            }
        }
    }


}


